import traceback

__author__ = "diego"
__copyright__ = "Copyright 2016, Argotec SL"
__license__ = "?"
__version__ = "0.1.4-tfg"
__maintainer__ = "Diego Fidalgo"
__email__ = "dfidalgo@argotec.es"
__status__ = "Development"


class Subject(object):
    event_types = []

    def __init__(self):
        self.callbacks = {}
        for event_type in self.event_types:
            self.callbacks[event_type] = []

    def add_callback(self, event_type, callback):
        if callback not in self.callbacks[event_type]:
            self.callbacks[event_type].append(callback)

    def remove_callback(self, event_type, callback):
        try:
            self.callbacks[event_type].remove(callback)
        except ValueError:
            pass
            # TODO: Raise exception

    def trigger_event(self, event_type, **kwargs):
        for callback in self.callbacks[event_type]:
            try:
                callback(**kwargs)
            except Exception as err:
                print("Exc from pattern:", err)
                print(traceback.format_exc())


class Singleton(type):
    _instances = {}

    def __call__(cls, *args, **kwargs):
        if cls not in cls._instances:
            cls._instances[cls] = super(Singleton, cls).__call__(*args, **kwargs)
        return cls._instances[cls]
